package com.yijia.system.service;

import java.util.List;
import com.yijia.common.core.domain.TreeSelect;
import com.yijia.common.core.domain.entity.SysDept;

/**
 * 部门管理 服务层
 *
 * @author yijia
 */
public interface ISysDeptService
{
    /**
     * 查询部门管理数据
     *
     * @param dept 部门信息
     * @return 部门信息集合
     */
    public List<SysDept> selectDeptList(SysDept dept);

    /**
     * 构建前端所需要树结构
     *
     * @param depts 部门列表
     * @return 树结构列表
     */
    public List<SysDept> buildDeptTree(List<SysDept> depts);

    /**
     * 构建前端所需要下拉树结构
     *
     * @param depts 部门列表
     * @return 下拉树结构列表
     */
    public List<TreeSelect> buildDeptTreeSelect(List<SysDept> depts);

    /**
     * 根据角色ID查询部门树信息
     *
     * @param roleId 角色ID
     * @return 选中部门列表
     */
    public List<Integer> selectDeptListByRoleId(Long roleId);

    /**
     * 根据部门ID查询信息
     *
     * @param deptId 部门ID
     * @return 部门信息
     */
    public SysDept selectDeptById(Long deptId);

    /**
     * 根据ID查询所有子部门（正常状态）
     *
     * @param deptId 部门ID
     * @return 子部门数
     */
    public int selectNormalChildrenDeptById(Long deptId);

    /**
     * 是否存在部门子节点
     *
     * @param deptId 部门ID
     * @return 结果
     */
    public boolean hasChildByDeptId(Long deptId);

    /**
     * 查询部门是否存在用户
     *
     * @param deptId 部门ID
     * @return 结果 true 存在 false 不存在
     */
    public boolean checkDeptExistUser(Long deptId);

    /**
     * 校验部门名称是否唯一
     *
     * @param dept 部门信息
     * @return 结果
     */
    public String checkDeptNameUnique(SysDept dept);

    /**
     * 新增保存部门信息
     *
     * @param dept 部门信息
     * @return 结果
     */
    public int insertDept(SysDept dept);

    /**
     * 修改保存部门信息
     *
     * @param dept 部门信息
     * @return 结果
     */
    public int updateDept(SysDept dept);

    /**
     * 删除部门管理信息
     *
     * @param deptId 部门ID
     * @return 结果
     */
    public int deleteDeptById(Long deptId);

    public List<SysDept> selectDeptListTree(SysDept dept);

    /**
     * 根据当前deptID 获取对应所有的油站id
     * @param dept
     * @return
     */
    public List<String>  selectDeptId(SysDept dept);

    /**
     * 根据or 查询
     * @param dept
     * @return
     */
    public List<SysDept> queryDeptList(SysDept dept);

    /**
     * 查询集团信息
     * @param dept
     * @return
     */
    public SysDept getGroupInfo(SysDept dept);

    /**
     * 查询积分规则共享
     * @param dept
     * @return
     */
    public  List<String>  deptIntegralInfoList(SysDept dept);

    /**
     * 查询电子卡规则共享
     * @param dept
     * @return
     */
    public  List<String>  deptCardInfoList(SysDept dept);
    /**
     * 查询优惠劵规则共享
     * @param dept
     * @return
     */
    public  List<String>  deptCouponInfoList(SysDept dept);

    /**
     * 修改油站基础信息
     * @param dept
     * @return
     */
    public int updateDeptInfo(SysDept dept);

    public List<String> selectDeptIdList(SysDept dept);

    /**
     *  查询分配代理管理
     * @param dept
     * @return
     */
    public List<SysDept> selectSysAgentList(SysDept dept);

    /**
     * 查询代理所有的集团
     * @param sysDept
     * @return
     */
    public List<SysDept> selectDeptAgentList(SysDept sysDept);

    /**
     * 根据集团查询站点信息。
     * @param sysDept
     * @return
     */
    public List<SysDept> searchDeptList(SysDept sysDept);

    /**
     * 根据参数查询对应的站点信息
     * @return
     */
    public List<String> levelDeptList(Long levelId);

    /**
     * 查询代理人 所有的集团信息
     * @param sysDept
     * @return
     */
    public  List<SysDept> selectGroupAgentList(SysDept sysDept);

    /**
     * 查询电子是否共享集团和站点信息
     * @param levelId
     * @return
     */
    public List<String> levelShareCardList(Long levelId);
}
